#!/bin/sh

# Abort on any non-zero return.
set -e

# Verbose shell execution.
set -x
set -v

case "$1" in

	atari|Atari)
		#
		# Atari install kit
		#
		mkdir -p release/atari
		mkdir -p release/atari/debian
		cp resc1440atari.bin release/atari/debian/resc1440.bin
		cp drv1440atari.bin release/atari/debian/drv1440.bin
		cp linuxatari release/atari/debian/linux
		cp sys_mapatari.gz release/atari/debian/sysmap.gz
		cp rootatari.bin release/atari/debian/root.bin
		cp m68k-specials/bootstra.ttp release/atari/debian/bootstra.prg
		cp m68k-specials/bootargs release/atari/debian/bootargs
		# cp m68k-specials/atari-install.txt release/atari/debian/install.doc
		(cd release/atari/ && lha a ../atariinstall.lzh debian/)
		;;
	amiga|Amiga)
		#
		# Amiga install kit 
		#
		mkdir -p release/amiga
		mkdir -p release/amiga/debian
		(cd release/amiga/ && lha x ../../m68k-specials/amiga-kit.lzh)
		cp resc1440amiga.bin release/amiga/debian/resc1440.bin
		cp drv1440amiga.bin release/amiga/debian/drv1440.bin
		cp linuxamiga release/amiga/debian/linux
		cp sys_mapamiga.gz release/amiga/debian/
		cp rootamiga.bin release/amiga/debian/root.bin
		# cd release/amiga/ && lha x ../../m68k-specials/amiga-install.lzh
		(cd release/amiga/ && lha a ../amigainstall.lzh debian/)
		;;
	mac|Mac)
		#
		# Mac install kit
		#
		mkdir -p release/mac
		mkdir -p release/mac/debian
		dd if=/dev/zero of=release/macinstall-hfs.img bs=1024 count=1440
		hformat -l "Debian/68k" release/macinstall-hfs.img
		hmount release/macinstall-hfs.img
		hcopy -r linuxmac :linux
		hcopy -r sys_mapmac.gz :System-Map.gz
		hcopy -r rootmac.bin :root.bin
		hcopy -m m68k-specials/Penguin-15.bin :
		hcopy -b m68k-specials/Penguin_Prefs.hqx :
		# hcopy -t m68k-specials/mac-install.txt :Install.doc
		humount release/macinstall-hfs.img
		;;
	*)
		echo "Unknown subarch \"$1\" !"
		;;
esac
