#include "dinstall.h"
#include <stdio.h>
#include INCLINGUA

int configure_keyboard_m (void) {
	return configure_keyboard(NULL);
}

int configure_keyboard (char *kbd)
{
  int rs=-1;
  char msg[]=MSG_SELECT_KEYBOARD_L;
  char title[]=MSG_SELECT_KEYBOARD;
  char *prefix;

#if #cpu (m68k)
  struct d_choices keymaps_ami[]={
    { "amiga-us",        "U.S. English (amiga)"      , 1},
    { "amiga-de",        "German (amiga)"            , 0}
  };
  int nchoices_ami=2;
  struct d_choices keymaps_ata[]={
    { "atari-us",        "U.S. English (atari)"      , 1},
    { "atari-de",        "German (atari)"            , 0},
    { "atari-se",        "Sweden (atari)"            , 0},
    { "atari-uk-falcon", "English for Atari Falcon"  , 0},
  };
  int nchoices_ata=4;
  struct d_choices keymaps_mac[]={
    { "mac-us-std",      "U.S. English (Mac, 82 keys)", 1},
    { "mac-us-ext",      "U.S. English (Mac, extended kbd)", 0}
  };
  int nchoices_mac=2;
  int nchoices;
#elif #cpu (sparc)
  struct d_choices keymaps[]={
    { "sunkeymap",       "U.S. English (QWERTY)"     , 1},
    { "sunt4-es",        "Spain (Type 4)"            , 0},
    { "sunt5-es",        "Spain (Type 5)"            , 0},
    { "sunt5-de-latin1", "Germany (Type 5)"          , 0},
    { "sunt5-fi-latin1", "Finland (Type 5)"          , 0},
    { "sunt5-fr-latin1", "France (Type 5)"           , 0},
    { "sunt5-ru",        "Russia (Type 5)"           , 0}
  };
  int nchoices=7;
#else
  struct d_choices keymaps[]={
    { "qwerty/us",			"U.S. English (QWERTY)", 1},
    { "azerty/be-latin1",		"Belgium", 0 },
    { "qwerty/bg",			"Bulgarian Cyrillic", 0 },
    { "qwerty/cf",			"French Canadian", 0 },
    { "qwertz/croat",			"Croatian", 0 },
    { "qwerty/cz-lat2",			"Czech", 0 },
    { "qwertz/de-latin1-nodeadkeys",	"Germany", 0 },
    { "qwerty/dk-latin1",		"Danish", 0 },
    { "dvorak/dvorak",			"Dvorak", 0 },
    { "qwerty/es",			"Spain", 0 },
    { "qwerty/fi-latin1",		"Finland", 0 },
    { "azerty/fr-latin1",		"France", 0 },
    { "qwerty/gr",			"Greek", 0 },
    { "qwerty/hebrew",			"Hebrew", 0 },
    { "qwertz/hu",			"Hungary", 0 },
    { "qwerty/is-latin1",		"Iceland", 0 },
    { "qwerty/it",			"Italy", 0 },
    { "qwerty/jp106",			"Japan", 0 },
    { "qwerty/no-latin1",		"Norway", 0 },
    { "qwerty/pl",			"Poland", 0 },
    { "qwerty/ru",			"Russia", 0 },
    { "qwerty/se-latin1",		"Sweden", 0 },
    { "qwertz/slovene",			"Slovene", 0 },
    { "fgGIod/tr_f-latin5",		"Turkish F", 0 },
    { "qwerty/uk",			"United Kingdom", 0 }
  };
  int nchoices=25;
#endif

    struct d_choices* choices;

#if #cpu (m68k)
    if (strcmp(Arch2, "Atari") == 0) {
	choices = keymaps_ata;
	nchoices = nchoices_ata;
	prefix="atari";
    }
    else if (strcmp(Arch2, "Amiga") == 0) {
	choices = keymaps_ami;
	nchoices = nchoices_ami;
	prefix="amiga";
    }
    else if (strcmp(Arch2, "Macintosh") == 0) {
	choices = keymaps_mac;
	nchoices = nchoices_mac;
	prefix="mac";
    }
    else if (strcmp(Arch2, "VME") == 0) {
	problemBox(MSG_VME_NO_KEYMAPS,MSG_INFORMATION);
	return 255;
    }
    else
	return 255;
#elif #cpu (sparc)
    prefix="sun";
    choices= keymaps;
#else
    prefix="i386";
    choices= keymaps;
#endif
    if (kbd) {
	int i;
	for (i=0;i<nchoices;i++) {
		if (0 == strcmp(choices[i].tag,kbd)) {
			rs=i;
			break;
		}
	}
	if (rs == -1)
		problemBox(MSG_WRONG_KBD,MSG_WRONG_PARAM);
    }
    if (rs == -1)
	    rs=menuBox(msg,title,choices,nchoices,1);

    if(rs!=-1)
      {
	FILE *kbdconf;
	if (NULL==(kbdconf=fopen("/tmp/kbdconf","w"))) {
		problemBox(MSG_CANT_OPEN_KBDCONF,MSG_WRITE_ERROR);
		return 1;
	}
	fprintf(kbdconf,"%s/%s",prefix,choices[rs].tag);
        fclose(kbdconf);
	sprintf(prtbuf,
		"zcat < /etc/keymaps.tgz | /bin/tarcat %s/%s.bmap | /bin/loadkmap",
		prefix,choices[rs].tag);
#ifdef _TESTING_
	problemBox(prtbuf,"Test Box");
#else
	system(prtbuf);
#endif
      }
#ifdef _TESTING_
    else
      {
	problemBox("Configuration Cancelled","Test Box");
      }
#endif
  return rs;
}


#ifdef _TESTING_
/* To test, compile using: make kbdconfig_test */
void main()
{
#if #cpu (m68k)
    Arch2 = "Atari";
#endif
    initScreen("Keyboard Config test program");

/* Use the following to test automatic kbd selection */
//    configure_keyboard("qwerty/es");

    configure_keyboard_m();

    finishScreen();
}
#endif
